#!/usr/local/bin/perl
$ENV{"PATH"} .= ":/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/dba/tools:/opt/dbamon/bin";
# ------------------------------------------------------------------------------
# Script   - dbamon_text.pl (The main script)
# Author   - Bill Border / AIT Database Americas
# Revision - 1.0 
# ------------------------------------------------------------------------------
$| = 1;
chop($P = `basename $0`);

use DBI;
require "cgi_handlers.pl";

$data_source = "dbi:mysql";
$database = "dbamon";

# Read WWW_Check:
chop($font = `grep 'WWW_Font:' /opt/dbamon/adm/dbamonrc | grep -v '^#' | awk '{ print \$2 }'`);
if ($font =~ /%/)
{
  $font =~ s/%/ /g;
  $font = "'$font'";
}

$font = "arial" if ! $font;

push(@INC,"/opt/dbamon/lib");
require "subs.pl";
require "subsDB.pl";
require "subsWWW.pl";

# See if DBAmon is configured to use Oracle
chop($use_oracle  = `grep Use_Oracle:  /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
chop($ORACLE_SID  = `grep ORACLE_SID:  /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
chop($ORACLE_HOME = `grep ORACLE_HOME: /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
if ($use_oracle eq "Y" && $ORACLE_SID ne "" && $ORACLE_HOME ne "")
{
  $ENV{'ORACLE_SID'}  = $ORACLE_SID;
  $ENV{'ORACLE_HOME'} = $ORACLE_HOME;
  $user = "dbamon";
  chop($passwd = `grep 'ORACLE_Password:' /opt/dbamon/adm/dbamonrc | grep -v '^#' | awk '{ print \$2 }'`);
  $data_source = "DBI:Oracle";
  $database = $ORACLE_SID;
}

#-----------------------------------------------------------------------------
#
# Subroutines
#
#-----------------------------------------------------------------------------

#------------------------------------------------------------------------------
sub msg
#------------------------------------------------------------------------------
{
  $msgmsg = $_[0];
  chop($date = `date +%Y/%m/%d-%H:%M:%S`);
  print "<br><font size=2>$date ${P} | <b>$msgmsg</b></font>\n";
}

#-----------------------------------------------------------------------------
sub getText 
#-----------------------------------------------------------------------------
{
  &get_request;
  $howfar = "-1";
  $action = $rqpairs{'action'};

  $text          = $rqpairs{'text'};
  $text_planning = $rqpairs{'text_planning'};

  print "<hr>"; 
  &msg("Action=$action") if $action ne "";

  if ($action eq "Save")
  {
    $howfar = "-2";

    &deleteText;

    # Put text into array
    @textArray          = split(/\n/,$text);
    @textArray_planning = split(/\n/,$text_planning);
  
    # Insert from array into table
    &insertTextArray;
    &insertTextArray_planning;
  }

  if ($action =~ /Delete/)
  {
    # Insert from array into table
    &deleteText;
  }
}

#-----------------------------------------------------------------------------
sub displayHeading 
#-----------------------------------------------------------------------------
{
  $links_include = `cat /opt/dbamon/lib/trans_links.txt`;

  print "Content-type: text/html\n\n
  <title>DBAmon Notepad</title>
  <body bgcolor=white link=darkblue vlink=darkblue><font face=$font>
  <table width=750><tr><td><img src='/dbamon/img/dbamonlogo.jpg' width=750>
  <tr bgcolor=wheat><td><font face=$font size=4>
      <center><img src='/dbamon/img/notepad.gif' > Notepad - Server/Instance: $system/$instance</center>
  </table>

  <table width=750>
  <tr>

   $links_include

  </table>
  ";
}

#-----------------------------------------------------------------------------
sub error 
#-----------------------------------------------------------------------------
{
   local($errorMsg) = @_;

   print "Content-type: text/html\n\n";
   print "<head><title> Database Function Error - Output</title></head>";
   print "<body>";

   print "<h2> The following database error occured - $date</h2>";
   print "<hr noshade>";
   print "</hr noshade>";
   print "<h4> $errorMsg</h4>";
   $sqlerror = $DBI::errstr;
   print "<br>SQL statement: $statement";
   print "<br>SQL error: $sqlerror";

   &PrintLinks;

   print "</body>";
   print "</html>";

   exit(1);
}

#-----------------------------------------------------------------------------
sub insertText 
#-----------------------------------------------------------------------------
{
  #print "text=$text\n";
  $statement  = "insert into dbamon.text (system,instance,text) values ";
  $statement .= "(\'$system\', \'$instance\', \'$text\')";
  #print "statement=$statement\n";
  #system("env");

  ##print "test2a\n";
  $rc = $dbh->do($statement) || &error('Failed_on_DB_do_insert');
  ##print "test2b\n";

  $insertcnt++;
  print "Rows inserted: $insertcnt\n";
}

#-----------------------------------------------------------------------------
sub printTop 
#-----------------------------------------------------------------------------
{
  print "
  <form method=\"POST\" action=\"/cgi-bin/dbamon_text.pl\?$system?$instance\">
  ";
}

#-----------------------------------------------------------------------------
sub insertTextArray 
#-----------------------------------------------------------------------------
{
  $insertcnt = 0;
  foreach $text (@textArray)
  {
    ##print;
    $insertkey++;
    #chop $text;

    # Remove naughty characters
    $text =~ s/'/"/g;
    ##print "text=$text\n";
    
    if (length($text) > 1000)
    {
      print "<br><b>ERROR:</b> Maximum line size of 1000 exceeded.<br>Click <b>Back</b> and try again.\n";
      print "<pre>$text</pre>";
      exit 1;
    }

    $statement  = "insert into dbamon.text (system,instance,text,seq) values ";
    $statement .= "(\'$system\', \'$instance\', \'$text\', $insertkey )";
    #print "statement=$statement\n";

    $rc = $dbh->do($statement) || &error('Failed_on_DB_do_insert');
    $insertcnt++;
  }
  &msg("Support Notes Rows Inserted: $insertcnt");

  $insertkey++;
  $text = "\n[$date - $insertcnt Rows Saved @ $ENV{'REMOTE_HOST'}]";
  $statement  = "insert into dbamon.text (system,instance,text,seq) values ";
  $statement .= "(\'$system\', \'$instance\', \'$text\', $insertkey )";
  $rc = $dbh->do($statement) || &error('Failed_on_DB_do_insert');
}
#-----------------------------------------------------------------------------
sub insertTextArray_planning
#-----------------------------------------------------------------------------
{
  $insertcnt = 0;
  foreach $text (@textArray_planning)
  {
    ##print;
    $insertkey++;
    #chop $text;

    # Remove naughty characters
    $text =~ s/'/"/g;
    ##print "text=$text\n";
    
    if (length($text) > 1000)
    {
      print "<br><b>ERROR:</b> Maximum line size of 1000 exceeded.<br>Click <b>Back</b> and try again.\n";
      print "<pre>$text</pre>";
      exit 1;
    }

    $statement  = "insert into dbamon.text (system,instance,text,seq,category) values ";
    $statement .= "(\'$system\', \'$instance\', \'$text\', $insertkey, \'P\' )";
    #print "statement=$statement\n";

    $rc = $dbh->do($statement) || &error('Failed_on_DB_do_insert');
    $insertcnt++;
  }
  &msg("Planning Notes Rows Inserted: $insertcnt");

  return if $insertcnt == 0; 

  $insertkey++;
  $text = "\n[$date - $insertcnt Rows Saved @ $ENV{'REMOTE_HOST'}]";
  $statement  = "insert into dbamon.text (system,instance,text,seq,category) values ";
  $statement .= "(\'$system\', \'$instance\', \'$text\', $insertkey, \'P\' )";
  $rc = $dbh->do($statement) || &error('Failed_on_DB_do_insert');
}

#-----------------------------------------------------------------------------
sub connectDBOld
#-----------------------------------------------------------------------------
{
  $dbh = DBI->connect("$data_source:$database", $user, $passwd) ||
         &error('Failed_on_DB_connect_in_updateDb');

  #---- Add a column
  $rc = $dbh->do("alter table text add category char(1)"); # || &error('Failed_on_DB_do_insert');
}

#-----------------------------------------------------------------------------
sub deleteText
#-----------------------------------------------------------------------------
{
  # Create the SQL DELETE statement
  $statement  = "delete from dbamon.text where system='$system' and instance='$instance'";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  &msg("Rows Deleted: $DBI::rows");
}

#-----------------------------------------------------------------------------
sub selectText
#-----------------------------------------------------------------------------
{
  # Create the SQL SELECT statement
  if ($dbamon_repos eq "O")
  {
    $statement  = "select 
       text,
       to_char(ts,'YYYY/MM/DD-HH24:MI:SS')
     from 
       dbamon.text
     where 
       system='$system' 
       and instance='$instance' 
       and category is null 
     order by 
       ts, seq";
  }
  else
  {
    $statement  = "select 
       text,
       dbamon.dateconvert_19(ts)
     from 
       dbamon.text
     where 
       system='$system' 
       and instance='$instance' 
       and category is null 
     order by 
       ts, seq";
  }
  ##print "$statement\n";

  #print "<p><b>Prior Notes:</b>\n";

  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');


  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    if ($selectcount == 0)
    {
      #print "<table border=0 width=80% >\n";
      #print "<tr bgcolor=slate><th width=10%><h5>Timestamp<th width=80%><h5>Note Text</tr>\n";
    }
    #print "<tr bgcolor=lightgrey><td nowrap><h6><font color=steelblue>$Data[1]</font><td><b>$Data[0]</b></tr>\n";

    $alltext .= "$Data[0]";

    $selectcount++;
  }

  $s_rows = $selectcount;
}

#-----------------------------------------------------------------------------
sub selectText_planning
#-----------------------------------------------------------------------------
{
  # Create the SQL SELECT statement

  if ($dbamon_repos eq "O")
  {
    $statement  = "select 
       text,
       to_char(ts,'YYYY/MM/DD-HH24:MI:SS')
     from 
       dbamon.text
     where 
       system='$system' 
       and instance='$instance' 
       and category='P' 
     order by 
       ts, seq";
  } 
  else
  {
    $statement  = "select 
       text,
       dbamon.dateconvert_19(ts)
     from 
       dbamon.text
     where 
       system='$system' 
       and instance='$instance' 
       and category='P' 
     order by 
       ts, seq";
  }
  ##print "$statement\n";

  #print "<p><b>Prior Notes:</b>\n";

  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    if ($selectcount == 0)
    {
      #print "<table border=0 width=80% >\n";
      #print "<tr bgcolor=slate><th width=10%><h5>Timestamp<th width=80%><h5>Note Text</tr>\n";
    }
    #print "<tr bgcolor=lightgrey><td nowrap><h6><font color=steelblue>$Data[1]</font><td><b>$Data[0]</b></tr>\n";

    $alltext_planning .= "$Data[0]";

    $selectcount++;
  }

  $p_rows = $selectcount;

  ##system("echo '' | mailx -s 'monitor--$P $system/$instance Count=$selectcount' bill.border\@thecompany.com") if $selectcount > 0;
}

#-----------------------------------------------------------------------------
#
# Main
#
#-----------------------------------------------------------------------------

# Read arguments
@words = split(/\?/,$ARGV[0]);

chop($system  = $words[0]);
$instance     = $words[1];

$instance = "." if $instance eq ""; 

##$system   = "testsystem";
##$instance = "testinstance";

# Display html header
&displayHeading;
&msg("Starting - system=$system instance=$instance"); 

##print "@ARGV[0] $system $instance\n";

# Connect to DB
&connectDB;

# See if I was called with text input  
# Put input in file in /tmp
&getText;

# Copy top of html file
&printTop;

# Read text from table for this system/instance
&selectText;
&selectText_planning;

# Copy bottom of html file

print "
<p><font size=3 face='$font'><b>Action:</b>
<select name=action>
  <option selected>Save
  <option>Delete_All_Data
</select>
<input type=submit value=' Perform Selected Action'>

<p><font size=2 face='$font'><b>Support Notes (Found $s_rows Prior Rows):</b></font><br>
<textarea NAME='text' COLS=100 ROWS=28 WRAP='off' STYLE='background:linen;font-size: 9pt;font-face:consolas;'>$alltext
</textarea>

<p><font size=2 face='$font'><b>Planning Notes (Found $p_rows Prior Rows):</b></font><br>
<textarea NAME='text_planning' COLS=100 ROWS=10 WRAP='off' STYLE='background:wheat;font-size:9pt;font-face:consolas;'>$alltext_planning
</textarea>

<p><hr><p>
<input type=submit value=' Perform Selected Action'>
</form>
";

print "<script language='JavaScript'> function back() { history.go($howfar); }</script>\n";
print "<hr><a href='javascript:back()'><font size=2><b>Return to DBAmon Instance Summary Page</font></a></b>";

&msg("Done"); 
exit 0;
