#------------------------------------------------------------------------------
sub error_fatal
#------------------------------------------------------------------------------
{
  &error_msg($_[0],"","","Y");   
}

#------------------------------------------------------------------------------
sub error
#------------------------------------------------------------------------------
{
  &error_msg($_[0],"","","Y");   
}

#------------------------------------------------------------------------------
sub error_msg
#------------------------------------------------------------------------------
# Send mail for dbamon internal error messages 
{
  print "\n\n*********** DBAmon Internal Error Notification - Start ************\n";
  ($m, $h, $f, $fatal) = @_;
  $tmperr = "$tmpdir/dbamon_tmperr";
  open(TMPERR,">$tmperr") || &msg("Cannot open output $tmperr - $!");

  $_ = $m;
  s/'//g;
  $m = $_;
 
  if ($fatal ne "Y")
  {
    $msgmod = "DBAmon | $titleraw[$h] | Mode: $modeout - $m";
  }
  else
  {
    $msgmod = "DBAmon Terminated - FATAL ERROR | $title[$h] | Mode: $modeout - $m";
  }

  print "DBAmon Error: $msgmod \n";

  ##print "hostnum="h

  #---- Put messages and "f" in my tmp file
  print TMPERR "--- DBAmon Program Error Message Notification ---\n\n";
  print TMPERR "Error Message: \n$m\n\n";
  
  if ($DBI::errstr)
  {
    print TMPERR "Most Recent DB Error:\n";
    print TMPERR "$DBI::errstr \n";
    print TMPERR "sql=$sql\n\n" if $sql;
  }

  if ($f ne "" && -e "$f")
  {
    print "Cat'ing file $f to error output\n";
    system("cat $f");
    print TMPERR "Error Details: (from tmp file: $f)\n";
    print TMPERR `cat $f`;
  }

  if (-d "$remshlog") 
  {
    print TMPERR "Most Recent Connection Error Details: (from tmp file: $remshlog)\n";
    print TMPERR `cat $remshlog 2>&1`;
  }

  close(TMPERR);

  #---- Write to stdout* log
  print `cat $tmperr` if -e "$tmperr";

  #---- Send mail to dbamon_admin
  print "Mailing DBAmon Internal Error Message to $dbamon_admin \n";
  $z = "cat $tmperr | dbamon_mailer -s '$msgmod' $dbamon_admin";
  system($z);

  #
  # Since a possible cause of pgm errors is that the download never
  # occured or the downloaded files were removed, we will now try
  # to re-download the files
  #
  if ($h > 0)
  {
    &downloadFlagOff($h);
  } 
  print "*********** DBAmon Internal Error Notification - End   ************\n\n\n";

  if ($fatal eq "Y")
  {
    print "*********** DBAmon Is Now Being TERMINATED rc=1 ************\n";
    $z = "cat $tmperr | dbamon_mailer -s '$msgmod' $admin_pager";
    exit 1;
  }
}

#------------------------------------------------------------------------------
1;
